/*
	摜k
*/

#include <stdio.h>
#include "image.h"

#define FALSE	0
#define TRUE	1

#define WEIGHT_HEAD	(194 + 200) /* 悭킩Ȃ... */
#define WEIGHT_PACK_HEAD	82
#define WEIGHT_PACK_DATA	25
#define WEIGHT_NOT_PACK_HEAD	82
#define WEIGHT_NOT_PACK_DATA	21
#define WEIGHT_MIN	(WEIGHT_HEAD + WEIGHT_NOT_PACK_HEAD + WEIGHT_NOT_PACK_DATA * 144)
#define WEIGHT_MAX	6242
#define DELAY_UNIT	((WEIGHT_MAX - WEIGHT_MIN + 32 / 2) / 32)

/*
	4Kx𓾂 (getBytẻ)
*/
static int getValue(Image img, int x, int y)
{
	int v = pointg(img, x, y);

	if(v < 64)
		return 3;
	else if(v < 160)
		return 2;
	else if(v < 224)
		return 1;
	else
		return 0;
}

/*
	摜f[^1byte ()
*/
static unsigned char getByte(Image img, int x, int y, int plane)
{
	int mask = (plane ? 1: 2);

	return
	(getValue(img, x, y + 0) & mask ? 0x01: 0) |
	(getValue(img, x, y + 1) & mask ? 0x02: 0) |
	(getValue(img, x, y + 2) & mask ? 0x04: 0) |
	(getValue(img, x, y + 3) & mask ? 0x08: 0) |
	(getValue(img, x, y + 4) & mask ? 0x10: 0) |
	(getValue(img, x, y + 5) & mask ? 0x20: 0) |
	(getValue(img, x, y + 6) & mask ? 0x40: 0) |
	(getValue(img, x, y + 7) & mask ? 0x80: 0);
}

/*
	kł邩? ()
*/
static int canPack(Image img, int x, int y, int plane)
{
	int v;

	if(x == img.width - 1)
		return FALSE;
	if(x == img.width - 2)
		return FALSE;

	v = getByte(img, x, y, plane);
	return v == getByte(img, x + 1, y, plane) && v == getByte(img, x + 2, y, plane);
}

/*
	摜1sk
*/
int packLine(unsigned char *buf, Image img, int y, int plane)
{
	int n, x = 0, v, weight = 0, delay;
	unsigned char *p = buf, *q, *r;

	r = p++;

	weight = WEIGHT_HEAD;

	while(x < img.width) {
		v = getByte(img, x, y, plane);

		if(canPack(img, x, y, plane)) {
			for(n = 0; n < 144 && x < img.width && v == getByte(img, x, y, plane); n++, x++)
				;
			*p++ = n;
			*p++ = v;

			weight += WEIGHT_PACK_HEAD + WEIGHT_PACK_DATA * n;
		} else {
			q = p++;
			for(n = 0; n < 113 && x < img.width && !canPack(img, x, y, plane); n++, x++)
				*p++ = getByte(img, x, y, plane);
			*q = (n + 144) & 0xff;

			weight += WEIGHT_NOT_PACK_HEAD + WEIGHT_NOT_PACK_DATA * n;
		}
	}

	delay = (WEIGHT_MAX - weight + DELAY_UNIT / 2) / DELAY_UNIT;
	if(delay < 0)
		delay = 0;
	else if(delay >= 32)
		delay = 32;
	*r = delay;

	return (int )(p - buf);
}

/* eof */
